import java.awt.Color;
import java.awt.geom.Point2D;

/**
 * Eine Clientversion von "Kaesekaestchen".
 * 
 * @author Q11
 * @version 2015-06-30
 */
public class Spiel
{
    private Rechteck [][] querlinie;
    private Rechteck [][] hochlinie;
    private Rechteck [][] kaestchen;
    private Rechteck [][] meinkaestchen;
    private Rechteck [][] gegnerkaestchen;
    private int x;
    private int y;

    private Beschriftung eigenName;
    private Beschriftung gegnerName;
    private Ellipse spieleranzeige;

    private int naechsteSpielerin;
    private final int spielerin01 = 1;
    private final int spielerin02 = 2;

    private Color rot  = new Color (255, 0, 0);
    private Color gelb = new Color (255, 255, 0);
    private Color grau = new Color (127, 127, 127);
    private Color weiss = new Color (255, 255, 255);
    private Color brot = new Color (185,92,121);
    private Color schwarz = new Color (0,0,0);

    private String meinNick;
    private Color meineFarbe;

    private String gegnerNick;
    private Color gegnerFarbe;

    private Beschriftung eigenePunktzahl;
    private Beschriftung gegnerPunktzahl;

    /**
     * Erstelle ein Spielfeld ... :3 
     */
    public Spiel (int x, int y)
    {
        this.x = x;
        this.y = y;

        naechsteSpielerin = spielerin01;      

        Leinwand.erzeugeLeinwand ("Ksekstchen", 1205, 805, Color.white);

        querlinie = new Rechteck [x][y+1];
        hochlinie = new Rechteck [x+1][y];
        kaestchen = new Rechteck [x+8][y+8];

        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                querlinie[i][j] = new Rechteck();
                querlinie[i][j].setzeBreite(15);
                querlinie[i][j].setzeHoehe(5);
                querlinie[i][j].setzeFarbe(grau);
                querlinie[i][j].setzePosition(20*i+5,20*j+100);

                if (0 == j || y == j)
                {
                    querlinie[i][j].setzeFarbe(schwarz);
                }
            }
        }

        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                kaestchen[i][j] = new Rechteck();
                kaestchen[i][j].setzeBreite(15);
                kaestchen[i][j].setzeHoehe(15);
                kaestchen[i][j].setzeFarbe(weiss);
                kaestchen[i][j].setzePosition(20*i+5,20*j+105);
            }
        }

        for(int i = 0; i <= x; i++)
        {
            for(int j = 0; j < y; j++)
            {
                hochlinie[i][j] = new Rechteck();
                hochlinie[i][j].setzeBreite(5);
                hochlinie[i][j].setzeHoehe(15);
                hochlinie[i][j].setzeFarbe(grau);
                hochlinie[i][j].setzePosition(20*i,20*j+105);

                if (0 == i || x == i)
                {
                    hochlinie[i][j].setzeFarbe(schwarz);
                }
            }
        }

        eigenName = new Beschriftung ();
        eigenName.setzeInhalt ("Sophia");
        eigenName.setzeFarbe (rot);
        eigenName.setzeSchriftgroesse (50);
        eigenName.setzePosition (1000, 30);
        eigenName.werdeSichtbar ();

        gegnerName = new Beschriftung ();
        gegnerName.setzeInhalt ("Lisa");
        gegnerName.setzeFarbe (gelb);
        gegnerName.setzeSchriftgroesse (50);
        gegnerName.setzePosition (50, 30);
        gegnerName.werdeSichtbar ();

        spieleranzeige = new Ellipse();
        spieleranzeige.setzeFarbe(grau);
        spieleranzeige.setzeHoehe (55);
        spieleranzeige.setzeBreite (55);
        spieleranzeige.setzePosition (510,20);
        spieleranzeige.werdeSichtbar ();

        eigenePunktzahl = new Beschriftung();
        eigenePunktzahl.setzeInhalt("0");
        eigenePunktzahl.setzePosition (1010,80);
        eigenePunktzahl.setzeSchriftgroesse (30);
        eigenePunktzahl.setzeFarbe(brot);
        eigenePunktzahl.werdeSichtbar();

        gegnerPunktzahl = new Beschriftung();
        gegnerPunktzahl.setzeInhalt("0");
        gegnerPunktzahl.setzePosition (50,80);
        gegnerPunktzahl.setzeSchriftgroesse (30);
        gegnerPunktzahl.setzeFarbe(brot);
        gegnerPunktzahl.werdeSichtbar();

        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Setze die Farbe der Spieleranzeige auf die der nchsten Spielerin,um anzuzeigen wer dran ist.
     */
    public void aendereAnzeige ()
    {
        if (naechsteSpielerin == spielerin01)
        {
            spieleranzeige.setzeFarbe (meineFarbe); 
        }
        else 
        {
            spieleranzeige.setzeFarbe (gegnerFarbe);
        }
    }

    /**
     * Prfe ob die Spalte voll ist und wechsle die Spielerin nach jedem Zug.
     */
    public void wirfNaechsteSpielerinEin (int Spaltennummer)
    {
        if (naechsteSpielerin == spielerin01)
        {
            naechsteSpielerin = spielerin02;
        }
        else 
        {
            naechsteSpielerin = spielerin01;
        }

        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Wirf einen Chip in eine beliebige Spalte ein.
     */
    private void wirfEin (int Spaltennummer)
    {

    }

    /**
     * Fange an.
     */
    public void fangeAn ()
    {
        /*
         * Faerbe das Spielfeld.
         */
        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                querlinie[i][j].setzeFarbe (grau);

                if (0 == j || y == j)
                {
                    querlinie[i][j].setzeFarbe(schwarz);
                }

                querlinie[i][j].werdeSichtbar ();
            }
        }

        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                kaestchen[i][j].setzeFarbe (weiss);
                kaestchen[i][j].werdeSichtbar ();
            }
        }

        for(int i = 0; i <= x; i++)
        {
            for(int j = 0; j < y; j++)
            {
                hochlinie[i][j].setzeFarbe (grau);

                if (0 == i || x == i)
                {
                    hochlinie[i][j].setzeFarbe(schwarz);
                }

                hochlinie[i][j].werdeSichtbar ();
            }
        }

        gegnerPunktzahl.setzeInhalt("0");
        eigenePunktzahl.setzeInhalt("0");

        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Hre auf.
     */
    public void hoereAuf ()
    {
        /*
         * Mache das ganze Spielfeld unsichtbar..
         */
        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                querlinie[i][j].werdeUnsichtbar ();
            }
        }

        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                kaestchen[i][j].werdeUnsichtbar ();
            }
        }

        for(int i = 0; i <= x; i++)
        {
            for(int j = 0; j < y; j++)
            {
                hochlinie[i][j].werdeUnsichtbar ();
            }
        }

        Leinwand.gibLeinwand ().erneuere ();

        /*
         * Lass Spielerin02 im nchsten Spiel wieder beginnen.
         */
        naechsteSpielerin = spielerin01;
    }

    /**
     * Aendere meinen Namen.
     */
    public void setzeMeinenNamen (String neuerName)
    {
        meinNick = neuerName;

        eigenName.setzeInhalt (neuerName);
        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Aendere meine Farbe.
     */
    public void setzeMeineFarbe (Color neueFarbe)
    {
        meineFarbe = neueFarbe;

        eigenName.setzeFarbe (neueFarbe);
        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Aendere den Namen meines Gegners.
     */
    public void setzeGegnerNamen (String neuerName)
    {
        gegnerNick = neuerName;

        gegnerName.setzeInhalt (neuerName);
        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Aendere die Farbe meines Gegners.
     */
    public void setzeGegnerFarbe (Color neueFarbe)
    {
        gegnerFarbe = neueFarbe;

        gegnerName.setzeFarbe (neueFarbe);
        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Nenne die X-Koordinate der angeklickten Querlinie.
     */
    public int gibQuerlinieX(Point2D punkt)
    {
        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                if (querlinie[i][j].enthaelt (punkt))
                {
                    return i;
                }
            }
        }

        return -1;
    }

    /**
     * Nenne die Y-Koordinate der angeklickten Querlinie.
     */
    public int gibQuerlinieY(Point2D punkt)
    {
        for(int i = 0; i < x; i++)
        {
            for(int j = 0; j <= y; j++)
            {
                if (querlinie[i][j].enthaelt (punkt))
                {
                    return j;
                }
            }
        }

        return -1;
    }

    /**
     * Nenne die X-Koordinate der angeklickten Hochlinie.
     */
    public int gibHochlinieX (Point2D punkt)
    {
        for (int i = 0; i <= x; i++)
        {
            for (int j = 0; j < y; j++)
            {
                if (hochlinie[i][j].enthaelt (punkt))
                {
                    return i;
                }
            }
        }

        return -1;
    }

    /**
     * Nenne die Y-Koordinate der angeklickten Hochlinie.
     */
    public int gibHochlinieY (Point2D punkt)
    {
        for (int i = 0; i <= x; i++)
        {
            for (int j = 0; j < y; j++)
            {
                if (hochlinie[i][j].enthaelt (punkt))
                {
                    return j;
                }
            }
        }

        return -1;
    }

    /**
     * Farbe eines Hochbalkens ndern.
     */
    public void faerbeHochbalken (String name, int i, int j)
    {
        if (name.equals (meinNick))
        {
            hochlinie[i][j].setzeFarbe (meineFarbe);
            Leinwand.gibLeinwand ().erneuere ();
        }
        else
        {
            hochlinie[i][j].setzeFarbe (gegnerFarbe);
            Leinwand.gibLeinwand ().erneuere ();
        }
    }

    /**
     * Farbe eines Querbalkens ndern.
     */
    public void faerbeQuerbalken (String name, int i, int j)
    {
        if (name.equals (meinNick))
        {
            querlinie[i][j].setzeFarbe (meineFarbe);
            Leinwand.gibLeinwand ().erneuere ();
        }
        else
        {
            querlinie[i][j].setzeFarbe (gegnerFarbe);
            Leinwand.gibLeinwand ().erneuere ();
        }
    }

    /**
     * Farbe eines Kstchens ndern.
     */
    public void faerbeKaestchen (String name, int i, int j)
    {
        if (name.equals (meinNick))
        {
            kaestchen[i][j].setzeFarbe (meineFarbe);
            Leinwand.gibLeinwand ().erneuere ();
        }
        else
        {
            kaestchen[i][j].setzeFarbe (gegnerFarbe);
            Leinwand.gibLeinwand ().erneuere ();
        }
    }
}